#!/usr/bin/perl

use IO::Socket;
# this script checks if given ftp server can really be used for ftp bounce


$|=1;


sub nb_listen {
  my ($sock, $timeout)=(@_);
  my $resp='';
  my $i=0;
  my $j=0;
  while (($resp eq '') && ($j<$timeout)) {
    $resp=<$sock>;
    sleep(++$i);
    $j=$j+$i;
  }
  $resp;
}

sub check_port {
  my ($ip_ftp, $port)=(@_);
  my $test_open='no';
  my $test_close='no';
  my $ip='216,239,59,104';
  my $resp='';
  my $is_open=0;
  my $sock = IO::Socket::INET->new(PeerAddr => $ip_ftp,
                                     PeerPort => 'ftp(21)',
				     Proto    => 'tcp',
				     Blocking => 0);
  if ($sock) {
    $resp=&nb_listen($sock, 10);
#print " 1 - $resp";
    print $sock "user ftp\r\n";
    $resp=&nb_listen($sock, 10);
#print " 2 - $resp";
    if ($resp =~ m/^331 /) {
      print $sock "pass ftp\r\n";
      $resp=&nb_listen($sock, 10);
#print " 3 - $resp";
      if ($resp =~ m/^230 /) {
	print $sock "port $ip,$port\r\n";
	$resp=&nb_listen($sock, 10);
#print " 4 - $resp";
	if ($resp =~ m/^200 /) {
          print $sock "list\r\n";
          my $resp=&nb_listen($sock, 240);
#print " 5 - $resp";
          if (!($resp =~ m/^425 /)) {
            $resp=&nb_listen($sock, 240);
#print " 6 - $resp";
            if (!($resp =~ m/^426 /)) {
	      $is_open=1;
	    }
	  }
	}
      }
    }
  }
  close($sock);
  $is_open;
}

sub check_ip {
  my ($ip)=(@_);
  my $works=0;
  my $port_opened='0,80';
  my $port_closed='0,81';
  my $should_be_opened=&check_port($ip, $port_opened);
  my $should_be_closed=&check_port($ip, $port_closed);
  if (
       ($should_be_opened==1) &&
       ($should_be_closed==0)
     ) {
    $works=1;
  } else {
    $works=0;
  }
  $works;
}

sub check_ip_list {
  my ($ip_list)=(@_);
  my $logname='LOG-' . int(rand(9999));
#  my $results='';
#print("DBG: $ip_list\n");
  my $working='';
  my @ip_list = split(/ /, $ip_list);
#  my $tmp=@ip_list ; print("$logname: $tmp addresses\n");
  for(my $i=0; $i<@ip_list; $i++) {
    my $ip=$ip_list[$i];
    open(LOG, ">> $logname");
print LOG ("ip=$ip\n");
    my $is_working=&check_ip($ip);
#    $results = $results . "$ip is working: $is_working\n";
    print LOG ("$ip is working: $is_working\n");
    close(LOG);
  }
#print("DBG: finished\n");
  open(LOG, ">> $logname");
  print LOG ("FINISHED\n");
  close(LOG);
}




# MAIN


my $ips=$ARGV[0];
#print("DBG: $ips\n");
&check_ip_list($ips);


